require 'renzokugen/shelve'
module Renzokugen
  class ShelveGenerator
    SHELVE_LETTERS= %w{ A B C D E H K L M N T V Z}
    attr_accessor :shelves, :hash

    def initialize hash
      @hash = hash
      @shelves = []
    end

    def create_shelves
      @hash.each do |key, value|
        letters = get_letters value[:letters]
        generate_shelves key, value[:range], letters
      end
      @shelves
    end

    def to_file file
      File.open(file, "w+") do |f|
        @shelves.each { |shelve| f.puts shelve }
      end 
    end

    private

    def get_letters letter_param
      letters = SHELVE_LETTERS
      unless letter_param == :all
        letters =  letter_param
      end
      letters
    end

    def generate_shelve key, shelve, letter
      @shelves << Renzokugen::Shelve.new(key.to_s, shelve.to_s, letter).to_s
    end

    def generate_shelves key, range, letters
      range.each do |shelve|
        letters.each do |letter|
          generate_shelve key, shelve, letter
        end
      end
    end
  end
end
